//importing the required methods
import { csv, select } from 'd3';
import { scatterPlot } from './scatterPlot';

//Saving the iris dataset url in a constant variable 
const csvUrl = 'https://gist.githubusercontent.com/SreejaBellamkonda/4e1e0146c17b827d7df2cac49c46f206/raw/2f713d2cc3863fed23baf9d9289d2b7bd82559ae/Irisdata.csv'
const parseRow = (d) => {
  d.sepal_length = +d.sepal_length;
  d.sepal_width = +d.sepal_width;
  d.petal_length = +d.petal_length;
  d.petal_width = +d.petal_width;
  return d;
};

//defining the width and height of the svg
const width = window.innerWidth;
const height = window.innerHeight;
//appending the svg to the html body
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

//creating the main function and calling the scatterplot function in it
const main = async () => {
  svg.call(
    scatterPlot()
      .width(width)
      .height(height)
    //loading the csv data
      .data(await csv(csvUrl, parseRow))
      .xValue((d) => d.petal_width)
      .yValue((d) => d.sepal_length)
      .symbolValue((d) => d.species)
      .margin({
        top: 20,
        right: 20,
        bottom: 40,
        left: 50,
      })
      .size(100)
  );
};
main();
